(function(window,document,undefined){function Flow(opts){this.version="2.0.0-beta2";this.support=(typeof File!=="undefined"&&typeof Blob!=="undefined"&&typeof FileList!=="undefined"&&(!!Blob.prototype.slice||!!Blob.prototype.webkitSlice||!!Blob.prototype.mozSlice||false));if(!this.support){return}this.files=[];this.defaults={chunkSize:1024*1024,forceChunkSize:false,simultaneousUploads:3,singleFile:false,fileParameterName:"file",progressCallbacksInterval:500,speedSmoothingFactor:0.1,query:{},headers:{},withCredentials:false,preprocess:null,method:"multipart",prioritizeFirstAndLastChunk:false,target:"/",testChunks:true,generateUniqueIdentifier:null,maxChunkRetries:0,chunkRetryInterval:null,permanentErrors:[404,415,500,501]};this.opts={};this.events=[];var $=this;this.onDrop=function(event){event.stopPropagation();event.preventDefault();var dataTransfer=event.dataTransfer;if(dataTransfer.items&&dataTransfer.items[0].webkitGetAsEntry){$.webkitReadDataTransfer(event)}else{$.addFiles(dataTransfer.files,event)}};this.preventEvent=function(event){event.preventDefault()};this.opts=Flow.extend({},this.defaults,opts||{})}Flow.prototype={on:function(event,callback){this.events.push(event.toLowerCase(),callback)},fire:function(event,args){args=Array.prototype.slice.call(arguments);event=event.toLowerCase();var preventDefault=false;for(var i=0;i<=this.events.length;i+=2){if(this.events[i]===event){preventDefault=this.events[i+1].apply(this,args.slice(1))===false||preventDefault}if(this.events[i]==="catchall"){preventDefault=this.events[i+1].apply(null,args)===false||preventDefault}}return !preventDefault},webkitReadDataTransfer:function(event){var $=this;var queue=event.dataTransfer.items.length;var files=[];each(event.dataTransfer.items,function(item){var entry=item.webkitGetAsEntry();if(!entry){return}if(entry.isFile){fileReadSuccess(item.getAsFile(),entry.fullPath)}else{entry.createReader().readEntries(readSuccess,readError)}});function readSuccess(entries){queue+=entries.length;each(entries,function(entry){if(entry.isFile){var fullPath=entry.fullPath;entry.file(function(file){fileReadSuccess(file,fullPath)},readError)}else{if(entry.isDirectory){entry.createReader().readEntries(readSuccess,readError)}}});decrement()}function fileReadSuccess(file,fullPath){file.relativePath=fullPath.substring(1);files.push(file);decrement()}function readError(fileError){throw fileError}function decrement(){if(--queue==0){$.addFiles(files,event)}}},generateUniqueIdentifier:function(file){var custom=this.opts.generateUniqueIdentifier;if(typeof custom==="function"){return custom(file)}var relativePath=file.relativePath||file.webkitRelativePath||file.fileName||file.name;return file.size+"-"+relativePath.replace(/[^0-9a-zA-Z_-]/img,"")},uploadNextChunk:function(preventEvents){var found=false;if(this.opts.prioritizeFirstAndLastChunk){each(this.files,function(file){if(!file.paused&&file.chunks.length&&file.chunks[0].status()==="pending"&&file.chunks[0].preprocessState===0){file.chunks[0].send();found=true;return false}if(!file.paused&&file.chunks.length>1&&file.chunks[file.chunks.length-1].status()==="pending"&&file.chunks[0].preprocessState===0){file.chunks[file.chunks.length-1].send();found=true;return false}});if(found){return found}}each(this.files,function(file){if(!file.paused){each(file.chunks,function(chunk){if(chunk.status()==="pending"&&chunk.preprocessState===0){chunk.send();found=true;return false}})}if(found){return false}});if(found){return true}var outstanding=false;each(this.files,function(file){if(!file.isComplete()){outstanding=true;return false}});if(!outstanding&&!preventEvents){this.fire("complete")}return false},assignBrowse:function(domNodes,isDirectory,singleFile){if(typeof domNodes.length==="undefined"){domNodes=[domNodes]}each(domNodes,function(domNode){var input;if(domNode.tagName==="INPUT"&&domNode.type==="file"){input=domNode}else{input=document.createElement("input");input.setAttribute("type","file");extend(domNode.style,{display:"inline-block",position:"relative",overflow:"hidden",verticalAlign:"top"});extend(input.style,{position:"absolute",top:0,right:0,fontFamily:"Arial",fontSize:"118px",margin:0,padding:0,opacity:0,cursor:"pointer"});domNode.appendChild(input)}if(!this.opts.singleFile&&!singleFile){input.setAttribute("multiple","multiple")}if(isDirectory){input.setAttribute("webkitdirectory","webkitdirectory")}var $=this;input.addEventListener("change",function(e){$.addFiles(e.target.files,e);e.target.value=""},false)},this)},assignDrop:function(domNodes){if(typeof domNodes.length==="undefined"){domNodes=[domNodes]}each(domNodes,function(domNode){domNode.addEventListener("dragover",this.preventEvent,false);domNode.addEventListener("dragenter",this.preventEvent,false);domNode.addEventListener("drop",this.onDrop,false)},this)},unAssignDrop:function(domNodes){if(typeof domNodes.length==="undefined"){domNodes=[domNodes]}each(domNodes,function(domNode){domNode.removeEventListener("dragover",this.preventEvent);domNode.removeEventListener("dragenter",this.preventEvent);domNode.removeEventListener("drop",this.onDrop)},this)},isUploading:function(){var uploading=false;each(this.files,function(file){if(file.isUploading()){uploading=true;return false}});return uploading},upload:function(){if(this.isUploading()){return}this.fire("uploadStart");var started=false;for(var num=1;num<=this.opts.simultaneousUploads;num++){started=this.uploadNextChunk(true)||started}if(!started){this.fire("complete")}},resume:function(){each(this.files,function(file){file.resume()})},pause:function(){each(this.files,function(file){file.pause()})},cancel:function(){for(var i=this.files.length-1;i>=0;i--){this.files[i].cancel()}},progress:function(){var totalDone=0;var totalSize=0;each(this.files,function(file){totalDone+=file.progress()*file.size;totalSize+=file.size});return totalSize>0?totalDone/totalSize:0},addFile:function(file,event){this.addFiles([file],event)},addFiles:function(fileList,event){var files=[];each(fileList,function(file){if(!(file.size%4096===0&&(file.name==="."||file.fileName==="."))&&!this.getFromUniqueIdentifier(this.generateUniqueIdentifier(file))){var f=new FlowFile(this,file);if(this.fire("fileAdded",f,event)){files.push(f)}}},this);if(this.fire("filesAdded",files,event)){each(files,function(file){if(this.opts.singleFile&&this.files.length>0){this.removeFile(this.files[0])}this.files.push(file)},this)}this.fire("filesSubmitted",files,event)},removeFile:function(file){for(var i=this.files.length-1;i>=0;i--){if(this.files[i]===file){this.files.splice(i,1);file.abort()}}},getFromUniqueIdentifier:function(uniqueIdentifier){var ret=false;each(this.files,function(file){if(file.uniqueIdentifier===uniqueIdentifier){ret=file}});return ret},getSize:function(){var totalSize=0;each(this.files,function(file){totalSize+=file.size});return totalSize}};function FlowFile(flowObj,file){this.flowObj=flowObj;this.file=file;this.name=file.fileName||file.name;this.size=file.size;this.relativePath=file.relativePath||file.webkitRelativePath||this.name;this.uniqueIdentifier=flowObj.generateUniqueIdentifier(file);this.chunks=[];this.paused=false;this.error=false;this.averageSpeed=0;this.currentSpeed=0;this._lastProgressCallback=Date.now();this._prevUploadedSize=0;this._prevProgress=0;this.bootstrap()}FlowFile.prototype={measureSpeed:function(){var smoothingFactor=this.flowObj.opts.speedSmoothingFactor;var timeSpan=Date.now()-this._lastProgressCallback;var uploaded=this.sizeUploaded();this.currentSpeed=Math.max((uploaded-this._prevUploadedSize)/timeSpan*1000,0);this.averageSpeed=smoothingFactor*this.currentSpeed+(1-smoothingFactor)*this.averageSpeed;this._prevUploadedSize=uploaded},chunkEvent:function(event,message){switch(event){case"progress":if(Date.now()-this._lastProgressCallback<this.flowObj.opts.progressCallbacksInterval){break}this.measureSpeed();this.flowObj.fire("fileProgress",this);this.flowObj.fire("progress");this._lastProgressCallback=Date.now();break;case"error":this.error=true;this.abort(true);this.flowObj.fire("fileError",this,message);this.flowObj.fire("error",message,this);break;case"success":if(this.error){return}this.flowObj.fire("fileProgress",this);this.flowObj.fire("progress");if(this.isComplete()){this.flowObj.fire("fileSuccess",this,message)}break;case"retry":this.flowObj.fire("fileRetry",this);break}},pause:function(){this.paused=true;this.abort()},resume:function(){this.paused=false;this.flowObj.upload()},abort:function(reset){this.currentSpeed=0;this.averageSpeed=0;var chunks=this.chunks;if(reset){this.chunks=[]}each(chunks,function(c){if(c.status()==="uploading"){c.abort();this.flowObj.uploadNextChunk()}},this)},cancel:function(){this.flowObj.removeFile(this)},retry:function(){this.bootstrap();this.flowObj.upload()},bootstrap:function(){this.abort(true);this.error=false;this._prevProgress=0;var round=this.flowObj.opts.forceChunkSize?Math.ceil:Math.floor;var chunks=Math.max(round(this.file.size/this.flowObj.opts.chunkSize),1);for(var offset=0;offset<chunks;offset++){this.chunks.push(new FlowChunk(this.flowObj,this,offset))}},progress:function(){if(this.error){return 1}if(this.chunks.length===1){this._prevProgress=Math.max(this._prevProgress,this.chunks[0].progress());return this._prevProgress}var bytesLoaded=0;each(this.chunks,function(c){bytesLoaded+=c.progress()*(c.endByte-c.startByte)});var percent=bytesLoaded/this.size;this._prevProgress=Math.max(this._prevProgress,percent>0.999?1:percent);return this._prevProgress},isUploading:function(){var uploading=false;each(this.chunks,function(chunk){if(chunk.status()==="uploading"){uploading=true;return false}});return uploading},isComplete:function(){var outstanding=false;each(this.chunks,function(chunk){var status=chunk.status();if(status==="pending"||status==="uploading"||chunk.preprocessState===1){outstanding=true;return false}});return !outstanding},sizeUploaded:function(){var size=0;each(this.chunks,function(chunk){if(chunk.status()==="success"){size+=chunk.endByte-chunk.startByte}else{size+=chunk.loaded}});return size},timeRemaining:function(){if(!this.averageSpeed){return 0}return Math.floor(Math.max(this.size-this.sizeUploaded(),0)/this.averageSpeed)},getType:function(){return this.file.type&&this.file.type.split("/")[1]},getExtension:function(){return this.name.substr((~-this.name.lastIndexOf(".")>>>0)+2).toLowerCase()}};function FlowChunk(flowObj,fileObj,offset){this.flowObj=flowObj;this.fileObj=fileObj;this.fileObjSize=fileObj.size;this.offset=offset;this.tested=false;this.retries=0;this.pendingRetry=false;this.preprocessState=0;this.loaded=0;this.total=0;var chunkSize=this.flowObj.opts.chunkSize;this.startByte=this.offset*chunkSize;this.endByte=Math.min(this.fileObjSize,(this.offset+1)*chunkSize);this.xhr=null;if(this.fileObjSize-this.endByte<chunkSize&&!this.flowObj.opts.forceChunkSize){this.endByte=this.fileObjSize}var $=this;this.progressHandler=function(event){if(event.lengthComputable){$.loaded=event.loaded;$.total=event.total}$.fileObj.chunkEvent("progress")};this.testHandler=function(event){var status=$.status();if(status==="success"){$.tested=true;$.fileObj.chunkEvent(status,$.message());$.flowObj.uploadNextChunk()}else{if(!$.fileObj.paused){$.tested=true;$.send()}}};this.doneHandler=function(event){var status=$.status();if(status==="success"||status==="error"){$.fileObj.chunkEvent(status,$.message());$.flowObj.uploadNextChunk()}else{$.fileObj.chunkEvent("retry",$.message());$.pendingRetry=true;$.abort();$.retries++;var retryInterval=$.flowObj.opts.chunkRetryInterval;if(retryInterval!==null){setTimeout(function(){$.send()},retryInterval)}else{$.send()}}}}FlowChunk.prototype={getParams:function(){return{flowChunkNumber:this.offset+1,flowChunkSize:this.flowObj.opts.chunkSize,flowCurrentChunkSize:this.endByte-this.startByte,flowTotalSize:this.fileObjSize,flowIdentifier:this.fileObj.uniqueIdentifier,flowFilename:this.fileObj.name,flowRelativePath:this.fileObj.relativePath,flowTotalChunks:this.fileObj.chunks.length}},getTarget:function(params){var target=this.flowObj.opts.target;if(target.indexOf("?")<0){target+="?"}else{target+="&"}return target+params.join("&")},test:function(){this.xhr=new XMLHttpRequest();this.xhr.addEventListener("load",this.testHandler,false);this.xhr.addEventListener("error",this.testHandler,false);var data=this.prepareXhrRequest("GET");this.xhr.send(data)},preprocessFinished:function(){this.preprocessState=2;this.send()},send:function(){var preprocess=this.flowObj.opts.preprocess;if(typeof preprocess==="function"){switch(this.preprocessState){case 0:preprocess(this);this.preprocessState=1;return;case 1:return;case 2:break}}if(this.flowObj.opts.testChunks&&!this.tested){this.test();return}this.loaded=0;this.total=0;this.pendingRetry=false;var func=(this.fileObj.file.slice?"slice":(this.fileObj.file.mozSlice?"mozSlice":(this.fileObj.file.webkitSlice?"webkitSlice":"slice")));var bytes=this.fileObj.file[func](this.startByte,this.endByte);this.xhr=new XMLHttpRequest();this.xhr.upload.addEventListener("progress",this.progressHandler,false);this.xhr.addEventListener("load",this.doneHandler,false);this.xhr.addEventListener("error",this.doneHandler,false);var data=this.prepareXhrRequest("POST",this.flowObj.opts.method,bytes);this.xhr.send(data)},abort:function(){var xhr=this.xhr;this.xhr=null;if(xhr){xhr.abort()}},status:function(){if(this.pendingRetry){return"uploading"}else{if(!this.xhr){return"pending"}else{if(this.xhr.readyState<4){return"uploading"}else{if(this.xhr.status==200){return"success"}else{if(this.flowObj.opts.permanentErrors.indexOf(this.xhr.status)>-1||this.retries>=this.flowObj.opts.maxChunkRetries){return"error"}else{this.abort();return"pending"}}}}}},message:function(){return this.xhr?this.xhr.responseText:""},progress:function(){if(this.pendingRetry){return 0}var s=this.status();if(s==="success"||s==="error"){return 1}else{if(s==="pending"){return 0}else{return this.total>0?this.loaded/this.total:0}}},prepareXhrRequest:function(method,paramsMethod,blob){var query=this.flowObj.opts.query;if(typeof query==="function"){query=query(this.fileObj,this)}query=extend(this.getParams(),query);var target=this.flowObj.opts.target;var data=null;if(method==="GET"||paramsMethod==="octet"){var params=[];each(query,function(v,k){params.push([encodeURIComponent(k),encodeURIComponent(v)].join("="))});target=this.getTarget(params);data=blob||null}else{data=new FormData();each(query,function(v,k){data.append(k,v)});data.append(this.flowObj.opts.fileParameterName,blob)}this.xhr.open(method,target);this.xhr.withCredentials=this.flowObj.opts.withCredentials;each(this.flowObj.opts.headers,function(v,k){this.xhr.setRequestHeader(k,v)},this);return data}};function extend(dst,src){each(arguments,function(obj){if(obj!==dst){each(obj,function(value,key){dst[key]=value})}});return dst}Flow.extend=extend;function each(obj,callback,context){if(!obj){return}var key;if(typeof(obj.length)!=="undefined"){for(key=0;key<obj.length;key++){if(callback.call(context,obj[key],key)===false){return}}}else{for(key in obj){if(obj.hasOwnProperty(key)&&callback.call(context,obj[key],key)===false){return}}}}Flow.each=each;Flow.FlowFile=FlowFile;Flow.FlowChunk=FlowChunk;window.Flow=Flow})(window,document);if(typeof module!=="undefined"){module.exports=window.Flow};